using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.HTMLUI;

namespace TestHTMLControl
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void menuItemExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void menuItemOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();

            if (dlg.ShowDialog() == DialogResult.OK)
            {
                html.LoadHTML(dlg.FileName);
            }
        }

        private void OnLinkClicked(object sender, Syncfusion.Windows.Forms.HTMLUI.LinkForwardEventArgs e)
        {
            AElementImpl element = sender as AElementImpl;
            if (element != null)
            {
                // Check the type
                switch (e.Path)
                {
                    case "variable":
                        HandleVariableConfiguration(element);
                        break;
                }
                
            }
            else
            {
                // Cancel the link
                e.Cancel = true;
            }
        }

        private void HandleVariableConfiguration(AElementImpl element)
        {
            // 1. Extract the attributes that we need
            Variable var = new Variable(element);
            // 2. Create a dialog
            ConfigureVariableDialog dlg = new ConfigureVariableDialog(var);
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                // do something
                element.InnerHTML = var.FormattedHTML;
            }
        }

    }
}