using System;
using System.Collections.Generic;
using System.Text;

using Syncfusion.Windows.Forms.HTMLUI;

namespace TestHTMLControl
{
    public class Variable
    {
        private string id;

        public string Id
        {
            get { return id; }
            set { id = value; }
        }
	
        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        private string type;

        public string Type
        {
            get { return type; }
            set { type = value; }
        }

        private string dataType;

        public string DataType
        {
            get { return dataType; }
            set { dataType = value; }
        }

        private double minimum;

        public double Minimum
        {
            get { return minimum; }
            set { minimum = value; }
        }

        private double maximum;

        public double Maximum
        {
            get { return maximum; }
            set { maximum = value; }
        }

        private object val;

        public object Value
        {
            get { return val; }
            set { val = value; }
        }

        public string StringValue
        {
            get { return val == null ? null : val.ToString(); }
            set { }
        }

        public string FormattedHTML
        {
            get
            {
                StringBuilder sb = new StringBuilder();
                // if the value is null or empty - we must show the name in square brackets
                if (val == null)
                {
                    sb.Append("[" + name + "]");
                }
                else
                {
                    sb.Append(StringValue);
                }
                // any choices ? if so, we must add them back in
                foreach (string key in choices.Keys)
                {
                    sb.Append("<choice name=\"" + key + "\" value=\"" + choices[key] + "\"/>");
                }

                return sb.ToString();
            }
        }
	
        private Dictionary<string, string> choices = new Dictionary<string,string>();

	    public Dictionary<string, string> Choices
	    {
		    get { return choices;}
		    set { choices = value;}
	    }
	

        public Variable(AElementImpl element)
        {
            try
            {
                id = element.Attributes["id"].Value;
                name = element.Attributes["name"].Value;
                type = element.Attributes["type"].Value;
                dataType = element.Attributes["datatype"].Value;

                minimum = element.Attributes["minimum"] == null ? Double.MinValue : Convert.ToDouble(element.Attributes["minimum"].Value);
                maximum = element.Attributes["maximum"] == null ? Double.MaxValue : Convert.ToDouble(element.Attributes["maximum"].Value);

                // choices
                if (type == "choice")
                {
                    foreach (IHTMLElement child in element.Children)
                    {
                        if (child.Name == "choice")
                        {
                            choices.Add(child.Attributes["name"].Value, child.Attributes["value"].Value);
                        }
                    }
                }
            }
            catch (Exception)
            {

            }
        }
	
    }
}
